import { AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, OnInit, OnChanges, SimpleChanges } from '@angular/core';
import { BounceableService } from './bounceable.service';
import { CollisionService } from './collision.service';
import { Vector } from './vector.class';
export declare class BounceableComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private _bounceableConfig;
    private _bounceableService;
    private _changeDetectorRef;
    private _collisionService;
    private _elementRef;
    position: Vector;
    momentum: Vector;
    width: number;
    height: number;
    weight: number;
    isMoving: boolean;
    isDragging: boolean;
    constructor(_bounceableConfig: any, _bounceableService: BounceableService, _changeDetectorRef: ChangeDetectorRef, _collisionService: CollisionService, _elementRef: ElementRef);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onMouseDown($event: Event): void;
    onMouseUp(momentum: Vector): void;
    step(): void;
    readonly bottom: number;
    readonly top: number;
    readonly right: number;
    readonly left: number;
    private handleCollisions();
    private handleOutOfContainerBounds();
    private respondToCollisionWithItem(item);
    private applyAirFriction();
    private updatePosition();
}
